/*********************************************************************************************************************
 * COPYRIGHT NOTICE
 * Copyright (c) 2018,ɿƼ
 * All rights reserved.
 * QQȺһȺ179029047()  Ⱥ244861897
 *
 * ݰȨɿƼУδҵ;
 * ӭλʹò޸ʱ뱣ɿƼİȨ
 *
 * @file       		MPU6050
 * @company	   		ɶɿƼ޹˾
 * @author     		ɿƼ(QQ3184284598)
 * @version    		鿴docversionļ 汾˵
 * @Software 		MDK FOR C251 V5.60
 * @Target core		STC32G12K128
 * @Taobao   		https://seekfree.taobao.com/
 * @date       		2019-04-30
 * @note		
					߶壺
					------------------------------------ 
					IIC
					SCL                 鿴SEEKFREE_MPU6050.HļڵMPU6050_SCL_PIN궨
					SDA                 鿴SEEKFREE_MPU6050.HļڵMPU6050_SDA_PIN궨  
					------------------------------------ 
 ********************************************************************************************************************/



#include "headfile.h"

int16 mpu6050_gyro_x,mpu6050_gyro_y,mpu6050_gyro_z;
int16 mpu6050_acc_x,mpu6050_acc_y,mpu6050_acc_z;


#define GET_MPU6050_SDA   		 	MPU6050_SDA_PIN
#define MPU6050_SCL_LOW()          	MPU6050_SCL_PIN = 0		//IO͵ƽ
#define MPU6050_SCL_HIGH()         	MPU6050_SCL_PIN = 1		//IOߵƽ  
#define MPU6050_SDA_LOW()          	MPU6050_SDA_PIN = 0		//IO͵ƽ
#define MPU6050_SDA_HIGH()         	MPU6050_SDA_PIN = 1		//IOߵƽ

#define ack 1      //Ӧ
#define no_ack 0   //Ӧ	

//-------------------------------------------------------------------------------------------------------------------
//  @brief      ģIICʱ
//  @return     void						
//  @since      v1.0
//  Sample usage:				IICͨѶʧܿԳjֵ
//-------------------------------------------------------------------------------------------------------------------
static void mpu6050_simiic_delay(void)
{
    uint16 j=MPU6050_IIC_DELAY;   
	while(j--);
}

//ڲʹãû
static void mpu6050_simiic_start(void)
{
	MPU6050_SDA_HIGH();
	MPU6050_SCL_HIGH();
	mpu6050_simiic_delay();
	MPU6050_SDA_LOW();
	mpu6050_simiic_delay();
	MPU6050_SCL_LOW();
}

//ڲʹãû
static void mpu6050_simiic_stop(void)
{
	MPU6050_SDA_LOW();
	MPU6050_SCL_LOW();
	mpu6050_simiic_delay();
	MPU6050_SCL_HIGH();
	mpu6050_simiic_delay();
	MPU6050_SDA_HIGH();
	mpu6050_simiic_delay();
}

//Ӧ(ack:SDA=0no_ack:SDA=0)
//ڲʹãû
static void mpu6050_simiic_sendack(unsigned char ack_dat)
{
    MPU6050_SCL_LOW();
	mpu6050_simiic_delay();
	if(ack_dat) MPU6050_SDA_LOW();
    else    	MPU6050_SDA_HIGH();

    MPU6050_SCL_HIGH();
    mpu6050_simiic_delay();
    MPU6050_SCL_LOW();
    mpu6050_simiic_delay();
}


static int mpu6050_sccb_waitack(void)
{
    MPU6050_SCL_LOW();

	mpu6050_simiic_delay();
	
	MPU6050_SCL_HIGH();
    mpu6050_simiic_delay();
	
    if(GET_MPU6050_SDA)           //ӦΪߵƽ쳣ͨʧ
    {

        MPU6050_SCL_LOW();
        return 0;
    }

    MPU6050_SCL_LOW();
	mpu6050_simiic_delay();
    return 1;
}

//ֽڷͳ
//c(Ҳǵַ)մӦ
//ǴӦλ
//ڲʹãû
static void mpu6050_send_ch(uint8 c)
{
	uint8 i = 8;
    while(i--)
    {
        if(c & 0x80)	MPU6050_SDA_HIGH();//SDA 
        else			MPU6050_SDA_LOW();
        c <<= 1;
        mpu6050_simiic_delay();
        MPU6050_SCL_HIGH();                //SCL ߣɼź
        mpu6050_simiic_delay();
        MPU6050_SCL_LOW();                //SCL ʱ
    }
	mpu6050_sccb_waitack();
}


//ֽڽճ
//ݣ˳Ӧ|Ӧ|ʹ
//ڲʹãû
static uint8 mpu6050_read_ch(uint8 ack_x)
{
    uint8 i;
    uint8 c;
    c=0;
    MPU6050_SCL_LOW();
    mpu6050_simiic_delay();
    MPU6050_SDA_HIGH();             

    for(i=0;i<8;i++)
    {
        mpu6050_simiic_delay();
        MPU6050_SCL_LOW();         //ʱΪͣ׼λ
        mpu6050_simiic_delay();
        MPU6050_SCL_HIGH();         //ʱΪߣʹЧ
        mpu6050_simiic_delay();
        c<<=1;
        if(GET_MPU6050_SDA) 
        {
            c+=1;   //λյݴc
        }
    }

	MPU6050_SCL_LOW();
	mpu6050_simiic_delay();
	mpu6050_simiic_sendack(ack_x);
	
    return c;
}


//-------------------------------------------------------------------------------------------------------------------
//  @brief      ģIICдݵ豸Ĵ
//  @param      dev_add			豸ַ(λַ)
//  @param      reg				Ĵַ
//  @param      dat				д
//  @return     void						
//  @since      v1.0
//  Sample usage:				
//-------------------------------------------------------------------------------------------------------------------
static void mpu6050_simiic_write_reg(uint8 dev_add, uint8 reg, uint8 dat)
{
	mpu6050_simiic_start();
    mpu6050_send_ch( (dev_add<<1) | 0x00);   //ַдλ
	mpu6050_send_ch( reg );   				 //ʹӻĴַ
	mpu6050_send_ch( dat );   				 //Ҫд
	mpu6050_simiic_stop();
}

//-------------------------------------------------------------------------------------------------------------------
//  @brief      ģIIC豸Ĵȡ
//  @param      dev_add			豸ַ(λַ)
//  @param      reg				Ĵַ
//  @param      type			ѡͨŷʽIIC   SCCB
//  @return     uint8			ؼĴ			
//  @since      v1.0
//  Sample usage:				
//-------------------------------------------------------------------------------------------------------------------
uint8 mpu6050_simiic_read_reg(uint8 dev_add, uint8 reg)
{
	uint8 dat;
	mpu6050_simiic_start();
    mpu6050_send_ch( (dev_add<<1) | 0x00);  //ַдλ
	mpu6050_send_ch( reg );   				//ʹӻĴַ

	
	mpu6050_simiic_start();
	mpu6050_send_ch( (dev_add<<1) | 0x01);  //ַӶλ
	dat = mpu6050_read_ch(no_ack);   				//ȡ
	mpu6050_simiic_stop();
	
	return dat;
}

//-------------------------------------------------------------------------------------------------------------------
//  @brief      ģIICȡֽ
//  @param      dev_add			豸ַ(λַ)
//  @param      reg				Ĵַ
//  @param      dat_add			ݱĵַָ
//  @param      num				ȡֽ
//  @param      type			ѡͨŷʽIIC   SCCB
//  @return     uint8			ؼĴ			
//  @since      v1.0
//  Sample usage:				
//-------------------------------------------------------------------------------------------------------------------
void mpu6050_simiic_read_regs(uint8 dev_add, uint8 reg, uint8 *dat_add, uint8 num)
{
	mpu6050_simiic_start();
    mpu6050_send_ch( (dev_add<<1) | 0x00);  //ַдλ
	mpu6050_send_ch( reg );   				//ʹӻĴַ

	
	mpu6050_simiic_start();
	mpu6050_send_ch( (dev_add<<1) | 0x01);  //ַӶλ
    while(--num)
    {
        *dat_add = mpu6050_read_ch(ack); //ȡ
        dat_add++;
    }
    *dat_add = mpu6050_read_ch(no_ack); //ȡ
	mpu6050_simiic_stop();
}

//-------------------------------------------------------------------------------------------------------------------
//  @brief      MPU6050Լ캯
//  @param      NULL
//  @return     void					
//  @since      v1.0
//  Sample usage:				
//-------------------------------------------------------------------------------------------------------------------
static uint8 mpu6050_self1_check(void)
{
    mpu6050_simiic_write_reg(MPU6050_DEV_ADDR, PWR_MGMT_1, 0x00);	//״̬
    mpu6050_simiic_write_reg(MPU6050_DEV_ADDR, SMPLRT_DIV, 0x07);   //125HZ
    if(0x07 != mpu6050_simiic_read_reg(MPU6050_DEV_ADDR, SMPLRT_DIV))
    {
		printf("mpu6050 init error.\r\n");
		return 1;
        //ԭ¼
        //1 MPU6050ˣµĸʼ
        //2 ߴûнӺ
        //3 Ҫ裬3.3V
		//4 ûеģIICĳʼ
    }

	return 0;

}


//-------------------------------------------------------------------------------------------------------------------
//  @brief      ʼMPU6050
//  @param      NULL
//  @return     void					
//  @since      v1.0
//  Sample usage:				
//-------------------------------------------------------------------------------------------------------------------
uint8 mpu6050_init(void)
{
    delay_ms(100);                                   //ϵʱ
		gpio_mode(P3_2, GPIO);
		gpio_mode(P3_3, GPIO);
    if(mpu6050_self1_check())
	{
		return 0;
	}
    mpu6050_simiic_write_reg(MPU6050_DEV_ADDR, PWR_MGMT_1, 0x00);	//״̬
    mpu6050_simiic_write_reg(MPU6050_DEV_ADDR, SMPLRT_DIV, 0x07);   //125HZ
    mpu6050_simiic_write_reg(MPU6050_DEV_ADDR, MPU6050_CONFIG, 0x04);       //
    mpu6050_simiic_write_reg(MPU6050_DEV_ADDR, GYRO_CONFIG, 0x18);  //2000
    mpu6050_simiic_write_reg(MPU6050_DEV_ADDR, ACCEL_CONFIG, 0x10); //8g
	  mpu6050_simiic_write_reg(MPU6050_DEV_ADDR, User_Control, 0x00);
    mpu6050_simiic_write_reg(MPU6050_DEV_ADDR, INT_PIN_CFG, 0x02);
	return 1;
}



//-------------------------------------------------------------------------------------------------------------------
//  @brief      ȡMPU6050ٶȼ
//  @param      NULL
//  @return     void
//  @since      v1.0
//  Sample usage:				ִиúֱӲ鿴Ӧı
//-------------------------------------------------------------------------------------------------------------------
void mpu6050_get_accdata(void)
{
    uint8 dat[6];

    mpu6050_simiic_read_regs(MPU6050_DEV_ADDR, ACCEL_XOUT_H, dat, 6);  
    mpu6050_acc_x = (int16)(((uint16)dat[0]<<8 | dat[1]));
    mpu6050_acc_y = (int16)(((uint16)dat[2]<<8 | dat[3]));
    mpu6050_acc_z = (int16)(((uint16)dat[4]<<8 | dat[5]));
}


//-------------------------------------------------------------------------------------------------------------------
//  @brief      ȡMPU6050
//  @param      NULL
//  @return     void
//  @since      v1.0
//  Sample usage:				ִиúֱӲ鿴Ӧı
//-------------------------------------------------------------------------------------------------------------------
void mpu6050_get_gyrodata(void)
{
    uint8 dat[6];

    mpu6050_simiic_read_regs(MPU6050_DEV_ADDR, GYRO_XOUT_H, dat, 6);  
    mpu6050_gyro_x = (int16)(((uint16)dat[0]<<8 | dat[1]));
    mpu6050_gyro_y = (int16)(((uint16)dat[2]<<8 | dat[3]));
    mpu6050_gyro_z = (int16)(((uint16)dat[4]<<8 | dat[5]));
}


MPU6050_DATA xdata mpu_data = {0};  //6050ݣտʼֶʼ

void mpu6050_read_acc(void);	 //ȡԭʼֵ
void mpu6050_read_gyro(void);
void cal_acc_offset(int* acc_data);//ٶȼƲֵƫ
void cal_gyro_offset(int* gyro_data);

//------ȡٶȼƵԭʼֵ16λ------
void mpu6050_read_acc(void)	//16λadc
{
	unsigned char buff[6];
	int acc_data[3] = {0};
	unsigned char i = 0;

//	for(i = 0;i<6;i++)
//	{
//		buff[i] = iic_read_addr_byte(ACC_ADDR + i);
//	}
	//iic_read_reg_bytes(MPU6050_DEV_ADDR, ACC_ADDR, buff, 6);	//ַȡ6050ãʡʱ
	mpu6050_simiic_read_regs(MPU6050_DEV_ADDR, ACCEL_XOUT_H, buff, 6);  
	acc_data[0] = (int)(((uint16)buff[0] << 8) | buff[1]);//x8λ8λϵ8λ
	acc_data[1] = (int)(((uint16)buff[2] << 8) | buff[3]);
	acc_data[2] = (int)(((uint16)buff[4] << 8) | buff[5]);

	cal_acc_offset(acc_data);

	mpu_data.acc_data.x = (acc_data[0] - mpu_data.acc_offset.x);
	mpu_data.acc_data.y = (acc_data[1] - mpu_data.acc_offset.y);
	mpu_data.acc_data.z = (acc_data[2] - mpu_data.acc_offset.z);
//	mpu_data.acc_data.x = acc_data[0];
//	mpu_data.acc_data.y = acc_data[1];
//	mpu_data.acc_data.z = acc_data[2];
//	mpu_data.acc_data.z = acc_data[2];

}

//------ȡԭʼֵ-----
//עǵƫ¶Ⱥйء
void mpu6050_read_gyro(void)
{
	unsigned char buff[6];
	int gyro_data[3] = {0};
	unsigned char i = 0;

//	for(i = 0;i<6;i++)	//ظȡ6αȽ޸iicһζȡ
//	{
//		buff[i] = iic_read_addr_byte(GYRO_ADDR + i);
//	}

	//iic_read_reg_bytes(MPU6050_DEV_ADDR, GYRO_ADDR, buff, 6);
	mpu6050_simiic_read_regs(MPU6050_DEV_ADDR, GYRO_XOUT_H, buff, 6);  	
	gyro_data[0] = (int)(((uint16)buff[0] << 8) | buff[1]);//x8λ8λϵ8λ
	gyro_data[1] = (int)(((uint16)buff[2] << 8) | buff[3]);
	gyro_data[2] = (int)(((uint16)buff[4] << 8) | buff[5]);

	cal_gyro_offset(gyro_data);//ԭʼݣƫ

	mpu_data.gyro_data.x = gyro_data[0] - mpu_data.gyro_offset.x + 0;
	mpu_data.gyro_data.y = gyro_data[1] - mpu_data.gyro_offset.y ;
	mpu_data.gyro_data.z = gyro_data[2] - mpu_data.gyro_offset.z ;
	
}

/*
**ٶȼƲֵǸտʼƫԭʼֵۼӣƽΪƫ
**ԺȡļٶȵֵҪȥƫ
**һʼѭһֱۼӶΣϸУѭһֱۼӵĻۼӵʵһ
**Ҫѭ棬ÿȡһμٶȵֵۼһΣЧݡ
**2017.12.11-----//һҪעԼͺȡֵΧ,ΪСûע⵽˷˺ܶʱ
*/
static void cal_acc_offset(int* acc_data)
{
	if(ACC_OFFSET_FLAG)
	{
		static unsigned int i = 0;	   //ԭ⴦һʼiΪunsigned charʾ256ȴд1000									
		static long int xdata acc_x_temp = 0, acc_y_temp = 0, acc_z_temp = 0;
		
		if(i == 0) //ÿһ
		{
			acc_x_temp = 0;
			acc_y_temp = 0; 
			acc_z_temp = 0;
		}
	
		acc_x_temp+= acc_data[0];
		acc_y_temp+= acc_data[1];
		acc_z_temp+= acc_data[2];
		i++;
	
		if(i == 500)
		{
			mpu_data.acc_offset.x = acc_x_temp/(float)i;
			mpu_data.acc_offset.y = acc_y_temp/(float)i;
			mpu_data.acc_offset.z = acc_z_temp/(float)i;
	
			i = 0;
			return;	
		}
	}
}
/*
//ƫУ׼
//ַʹһʼݲ׼ȷΪǰ200ûбУ׼ܲһʼͽУ׼
//ǸտʼȡȡǰƽֻǸտʼǺܾȷǵһĳ̶ȣѾۼӵ2000ˣУ׼Ѿ
//ȷˣʱֹͣ mpu_data.gyro_offset 
*/

static void cal_gyro_offset(int* gyro_data)
{
	if(GYRO_OFFSET_FLAG)
	{
		static unsigned int i = 0;	 
		static long int xdata gyro_x_temp = 0, gyro_y_temp = 0, gyro_z_temp = 0;
		
		if(i == 0) 
		{
			gyro_x_temp = 0;
			gyro_y_temp = 0; 
			gyro_z_temp = 0;
		}
	
		gyro_x_temp+= gyro_data[0];
		gyro_y_temp+= gyro_data[1];
		gyro_z_temp+= gyro_data[2];
		i++;
	
		if(i == 500)		//ݲһУ׼ֵȻ¼У׼ֵ
		{
			mpu_data.gyro_offset.x = gyro_x_temp/(float)i;
			mpu_data.gyro_offset.y = gyro_y_temp/(float)i;
			mpu_data.gyro_offset.z = gyro_z_temp/(float)i;
	
			i = 0;
			return;	
		}
	}
}

//------------icm20602Ĵ------------------//

float acc_gyro_xyz[6] = {0,0,0,0,0,0};  //ٶȡٶ XYZֵ float 

//----------------------------------------------
//  @brief    ǽٶȺͽǶ
//  @param    gyro_x   ǻȡٶȣXᣩ
//  @param    gyro_z   ǻȡٶȣZᣩ
//  @param    acc      Ǽٶ
//  @return   (gyro/an)  ٶȱ׼
//  @return   (asin(acc/4096)*pi  Ƕȱ׼
//----------------------------------------------
float O_speed(float gyro_x, float gyro_z)
{
    float gyro;

    //ٶӳϳ
    gyro = 0.985*gyro_x - 0.174*gyro_z;
    return (gyro / an);
}

//üٶȼƼǶ
float O_angle(float acc_y, float acc_z)
{
    //ӳϳ
    return (atan2(acc_y, acc_z) * pi);
}


//-------------------------------------------
//  @brief      ˲(ã
//  @param      anglec   ýǶ
//  @param      Accel   ٶȼƽǶ
//  @param      Gyro    ǽٶ
//  @return     void    ͨangle,angle_dotȡ
//--------------------------------------------
volatile float anglec;float angle_dot;  // *ŽǶȣ*ŽǼٶ
float xdata dtc = 0.005;   //ʱ
float Q_angle=0.001, Q_gyro=0.001, R_angle=1;   //ԭֵ 0.001  0.001 10
    //Q󣬶̬Ӧ
static float Pk[2][2] = { {1, 0}, {0, 1 }};

static float Pdot[4] ={0,0,0,0};

static float q_bias=0, angle_err, PCt_0, PCt_1, E, K_0, K_1, t_0, t_1;

//-------------------------------------------------------
void Kalman_Filter_icm(float Accel,float Gyro)
{
    anglec +=(Gyro-q_bias) * dtc; ///Ԥֵ
    Pdot[0]=Q_angle - Pk[0][1] - Pk[1][0];
    Pdot[1]= -Pk[1][1];
    Pdot[2]= -Pk[1][1];
    Pdot[3]=Q_gyro;

    Pk[0][0] += Pdot[0] * dtc;
    Pk[0][1] += Pdot[1] * dtc;
    Pk[1][0] += Pdot[2] * dtc;
    Pk[1][1] += Pdot[3] * dtc;

    angle_err = Accel - anglec;///ֵ-Ԥֵ

    PCt_0 =  Pk[0][0];
    PCt_1 =  Pk[1][0];

    E = R_angle + PCt_0;

    K_0 = PCt_0 / E; ///
    K_1 = PCt_1 / E;

    t_0 = PCt_0;
    t_1 = Pk[0][1];

    Pk[0][0] -= K_0 * t_0;
    Pk[0][1] -= K_0 * t_1;
    Pk[1][0] -= K_1 * t_0;
    Pk[1][1] -= K_1 * t_1;

    anglec += K_0 * angle_err; ///ŽǶ=Ԥֵ+*(ֵ-Ԥֵ)
    q_bias  += K_1 * angle_err;
    angle_dot = Gyro-q_bias;
}

//-------------------------------------------
//  @brief      һ׻˲
//  @param      anglec   ýǶ𣨼Ĳ
//  @param      Accel   ٶȼƽǶ
//  @param      Gyro    ǽٶ
//  @return     void    ͨangle,angle_dotȡ
//--------------------------------------------
float a = 0.998;//˲ϵ 0.998

void complementary_filter(double Accel, double Gyro)
{
    anglec = a*(anglec + Gyro*dtc) + (1-a)*Accel;
}

//-------------------------------------------
//  @brief      ȡ3
//  @param      x       Ҫ
//  @return     y       źĵ
//--------------------------------------------
float invSqrt(float x) {
    float halfx = 0.5f * x;
    float y = x;
    long i = *(long*)&y;
    i = 0x5f375a86 - (i>>1);
    y = *(float*)&i;
    y = y * (1.5f - (halfx * y * y));
    return y;
}

/**********************************
//-------------Ԫ  ˲(ɿǿ)--------------//
**********************************/
#define delta_T      dtc  //msһ  

float I_ex, I_ey, I_ez;  // 
quaterInfo_t Q_info = {1,0,0,0};  // ȫԪ
eulerianAngles_t eulerAngle = {0,0,0}; //ŷ
float param_Kp = 3.0f;   // ٶȼ()ʱ50 (kpٶȼ (3.0
float param_Ki = 0.004f;   //ʵĻ 0.2   (kiƫ(0.004
//-------------------------------------------------------
/**
  * brief IMU_AHRSupdate_noMagnetic  ̬ںϣCrazeponyͺ㷨
  * ʹõǻ˲㷨ûʹKalman˲㷨
  * param float gx, float gy, float gz, float ax, float ay, float az
  *
  * return None
  */
void IMU_AHRSupdate_noMagnetic(float gx, float gy, float gz, float ax, float ay, float az)
{
    #define halfT  (0.5 * delta_T)
    float vx, vy, vz;    //ǰĻϵϵλ
    float ex, ey, ez;    //ԪֵٶȼƲֵ
    float q0 = Q_info.q0;
    float q1 = Q_info.q1;
    float q2 = Q_info.q2;
    float q3 = Q_info.q3;
    #define q0q0  (q0 * q0)
    #define q0q1  (q0 * q1)
    #define q0q2  (q0 * q2)
    #define q0q3  (q0 * q3)
    #define q1q1  (q1 * q1)
    #define q1q2  (q1 * q2)
    #define q1q3  (q1 * q3)
    #define q2q2  (q2 * q2)
    #define q2q3  (q2 * q3)
    #define q3q3  (q3 * q3)
//    float delta_2;

    //Լٶݽйһ õλٶ
    float norm = invSqrt(ax*ax + ay*ay + az*az);
    ax = ax * norm;
    ay = ay * norm;
    az = az * norm;

    //õ̬ԪɡҾеĵеԪء
    vx = 2*(q1q3 - q0q2);
    vy = 2*(q0q1 + q2q3);
    vz = q0q0 - q1q1 - q2q2 + q3q3;

    //ٶȼƲ̬֮
    ex = ay * vz - az * vy;
    ey = az * vx - ax * vz;
    ez = ax * vy - ay * vx;

    //òPIƫ
  //ͨ param_Kpparam_Ki 
  //ԿƼٶȼǻ̬ٶȡ
    I_ex += param_Ki * ex;   // integral error scaled by Ki   //ԭλdelta_T
    I_ey += param_Ki * ey;
    I_ez += param_Ki * ez;

    gx = gx + param_Kp*ex + I_ex;  //ԭ
    gy = gy + param_Kp*ey + I_ey;
    gz = gz + param_Kp*ez + I_ez;

         //Ԫ΢ַ̣halfTΪڵ1/2gx gy gzΪǽٶȣ¶֪ʹһԪ΢ַ
    q0 = q0 + (-q1*gx - q2*gy - q3*gz)*halfT;
    q1 = q1 + ( q0*gx + q2*gz - q3*gy)*halfT;
    q2 = q2 + ( q0*gy - q1*gz + q3*gx)*halfT;
    q3 = q3 + ( q0*gz + q1*gy - q2*gx)*halfT;

//    delta_2=(2*halfT*gx)*(2*halfT*gx)+(2*halfT*gy)*(2*halfT*gy)+(2*halfT*gz)*(2*halfT*gz);
//      //Ԫ    Ԫ΢ַ  Ԫ㷨ױϿΪǶױϿ ֻһף
//    q0 = (1-delta_2/8)*q0 + (-q1*gx - q2*gy - q3*gz)*halfT;
//    q1 = (1-delta_2/8)*q1 + (q0*gx + q2*gz - q3*gy)*halfT;
//    q2 = (1-delta_2/8)*q2 + (q0*gy - q1*gz + q3*gx)*halfT;
//    q3 = (1-delta_2/8)*q3 + (q0*gz + q1*gy - q2*gx)*halfT;

        // normalise quaternion
    norm = invSqrt(q0*q0 + q1*q1 + q2*q2 + q3*q3);
    Q_info.q0 = q0 * norm;
    Q_info.q1 = q1 * norm;
    Q_info.q2 = q2 * norm;
    Q_info.q3 = q3 * norm;

    eulerAngle.pitch = asin(2*(Q_info.q0*Q_info.q2 - Q_info.q1*Q_info.q3))*57.3f;
    eulerAngle.roll  = asin(2*(Q_info.q0*Q_info.q1 + Q_info.q2*Q_info.q3))*57.3f;
//    eulerAngle.yaw   = atan2(2*(Q_info.q1*Q_info.q2 + Q_info.q0*Q_info.q3),-2*Q_info.q2*Q_info.q2 -2*Q_info.q3*Q_info.q3 + 1)*57.3f;
    }

//-------------------------------------------
//  @brief      6˶ݵλ
//  @param      *values ݵ
//  @return     void    ͨȡ
//--------------------------------------------
//int16 icm_gyro_x,icm_gyro_y,icm_gyro_z;
//int16 icm_acc_x,icm_acc_y,icm_acc_z;
#define new_weight           0.35f
#define old_weight           0.65f
		
float Last_Angle_gx=0, Last_Angle_gy;

void IMU_getValues(float * values)
{					
	
//	values[0] = ((float)(((int *)&tp)[0])) / 16384.0;	//ٶȴ	λ +- g
//	values[1] = ((float)(((int *)&tp)[1])) / 16384.0;	//תϵ	16384 LSB/g, 1gӦ8192
//	values[2] = ((float)(((int *)&tp)[2])) / 16384.0;	//ٶ +-2g/S
//	Last_Angle_gx = values[3];		//һνٶ
//	Last_Angle_gy = values[4];
//	values[3] = ((float)(((int *)&tp)[4] - g_x)) / 32.768;	//Ǵ	λ +-
//	values[4] = ((float)(((int *)&tp)[5] - g_y)) / 32.768;	// +-500/S, 1/ Ӧ 65.536
//	values[5] = ((float)(((int *)&tp)[6] - g_z)) / 32.768;	//תϵ65.5 LSB/
//	
//	IMU_AHRSupdate_noMagnetic(values[3], values[4], values[5], values[0], values[1], values[2]);
	
	
	static float lastaccel[3]= {0,0,0};
	int i;
	values[0] = ((float)mpu6050_acc_x) * new_weight + lastaccel[0] * old_weight;
	values[1] = ((float)mpu6050_acc_y) * new_weight + lastaccel[1] * old_weight;
	values[2] = ((float)mpu6050_acc_z) * new_weight + lastaccel[2] * old_weight;
	for(i=0; i<3; i++)
	{
			lastaccel[i] = values[i];
	}

	values[3] = ((float)mpu_data.gyro_data.x) / 57.3f/ 16.4f;  //תΪ
	values[4] = ((float)mpu_data.gyro_data.y) / 57.3f/ 16.4f;
	values[5] = ((float)mpu_data.gyro_data.z) / 57.3f/ 16.4f;
	
	

}

//-------------------------------------------
//  @brief      жµ
//  @param      void
//  @return     void
//--------------------------------------------
#define Ramp_isr	P35
uint8 Ramp_Flag = 1;    //µ־λ
void Ramp_Judge(void)
{
    if(eulerAngle.pitch<-9)
    {
        Ramp_Flag = Ramp_up;
        Ramp_isr = 1;
			//gpio_set(P33_10,1);
    }
    if(eulerAngle.pitch>9)
    {
        Ramp_Flag = Ramp_down;
				Ramp_isr = 1;
        //gpio_set(P33_10,0);
    }
}


/*
**2017.12.5
**6050ԭʼݽд˲Ƕת
**ƽ˲
*/

void mpu6050_data_process(void)
{

	unsigned char i = 0,  j = 0;
	static unsigned char acc_filter_cnt = 0;//˲
	static unsigned char gyro_filter_cnt = 0;
	long int xdata acc_temp[3] = {0};//ٶ,ע⣬ܶΪ̬
	long int xdata gyro_temp[3] = {0};
	static int  acc_x_buf[ACC_FILTER_NUM] = {0}, //ڻ棬ÿһΣݶһ
	    	    acc_y_buf[ACC_FILTER_NUM] = {0},
	    	    acc_z_buf[ACC_FILTER_NUM] = {0};

	static int  gyro_x_buf[GYRO_FILTER_NUM] = {0}, //ڻ棬ÿһΣݶһ
   			    gyro_y_buf[GYRO_FILTER_NUM] = {0},
   	            gyro_z_buf[GYRO_FILTER_NUM] = {0};

	float xdata init_ax = 0,init_ay = 0,init_az = 0;
	float xdata acc_angle_x = 0,gyro_angle_x = 0;	//һ׻Ĳ


	mpu6050_read_acc();	 //ȡԭʼ
	mpu6050_read_gyro();

	init_ax =  (float)mpu_data.acc_data.x / ACC_G;	   //㵥λΪGĸٶȷ
	init_ay =  (float)mpu_data.acc_data.y / ACC_G;
	init_az =  (float)mpu_data.acc_data.z / ACC_G;

	acc_angle_x = atan(init_ax/init_az) * 180 / PI ;	//ٶȼxǶ
	gyro_angle_x = -(float)mpu_data.gyro_data.y / 7510.0;	 //ǼxǶ,7150??

	mpu_data.acc_angle.x = (int)one_filter(acc_angle_x,gyro_angle_x);		 //һ׻˲ȡƫxǶ
	mpu_data.acc_angle.y = (int)kalman_filter(acc_angle_x,gyro_angle_x);     //ȡ˲


//ٶȼݴ
//-----------------------------------------------------
	acc_x_buf[acc_filter_cnt] = mpu_data.acc_data.x;//ƽ˲ ,ݣһʼд˼ӣһֱ
	acc_y_buf[acc_filter_cnt] = mpu_data.acc_data.y;
	acc_z_buf[acc_filter_cnt] = mpu_data.acc_data.z;

	for(i=0;i<ACC_FILTER_NUM;i++)	//˲,ȡƽֵ
	{
		acc_temp[0]+= acc_x_buf[i];
		acc_temp[1]+= acc_y_buf[i];
		acc_temp[2]+= acc_z_buf[i];
	}

	//ڴ˽ У׼
	//---------------------------
	mpu_data.acc_filter.x = (acc_temp[0] / ACC_FILTER_NUM); //óx᷽ٶȣ λG
	mpu_data.acc_filter.y = (acc_temp[1] / ACC_FILTER_NUM);
	mpu_data.acc_filter.z = (acc_temp[2] / ACC_FILTER_NUM);
	//--------------------------		  

	acc_filter_cnt++;
	if(acc_filter_cnt == ACC_FILTER_NUM)
	{
		acc_filter_cnt = 0;
	}

//ݴ
//-----------------------------------------------------------
	gyro_x_buf[gyro_filter_cnt] = mpu_data.gyro_data.x;
	gyro_y_buf[gyro_filter_cnt] = mpu_data.gyro_data.y;
	gyro_z_buf[gyro_filter_cnt] = mpu_data.gyro_data.z;

	for(j=0;j<GYRO_FILTER_NUM;j++)	//˲,ȡƽֵ
	{
		gyro_temp[0]+= gyro_x_buf[j];
		gyro_temp[1]+= gyro_y_buf[j];
		gyro_temp[2]+= gyro_z_buf[j];
	}

	//ڴ˽ У׼
	//-----------------------------
	mpu_data.gyro_filter.x = gyro_temp[0]/GYRO_FILTER_NUM;
	mpu_data.gyro_filter.y = gyro_temp[1]/GYRO_FILTER_NUM;
	mpu_data.gyro_filter.z = gyro_temp[2]/GYRO_FILTER_NUM;
	//--------------------------

	gyro_filter_cnt++;
	if(gyro_filter_cnt == GYRO_FILTER_NUM)
	{
		gyro_filter_cnt = 0;
	}

	//Ϊ
	mpu_data.gyro_dps.x = (float)mpu_data.gyro_filter.x * GYRO_A;
	mpu_data.gyro_dps.y = (float)mpu_data.gyro_filter.y * GYRO_A;
	mpu_data.gyro_dps.z = (float)mpu_data.gyro_filter.z * GYRO_A;
//
//	//Ϊ
//	mpu_data.gyro_rad.x = (float)mpu_data.gyro_filter.x * GYRO_R;
//	mpu_data.gyro_rad.y = (float)mpu_data.gyro_filter.y * GYRO_R;
//	mpu_data.gyro_rad.z = (float)mpu_data.gyro_filter.z * GYRO_R;


}


void Attitude_Algorithm(void)
{
		mpu6050_get_accdata();
    mpu6050_read_acc();
		mpu6050_read_gyro();
    mpu6050_get_gyrodata();
		IMU_getValues(acc_gyro_xyz);
    IMU_AHRSupdate_noMagnetic(acc_gyro_xyz[3], acc_gyro_xyz[4], acc_gyro_xyz[5], acc_gyro_xyz[0], acc_gyro_xyz[1], acc_gyro_xyz[2]);
}

void Attitude_Algorithm_Init(void)
{
		uint16 i;
    //icm20602_init_spi();        //δicm20602ʱ,Էѭ
    for (i = 0; i < 100; ++i)
    {
        mpu6050_read_acc();
				mpu6050_read_gyro();
				delay_ms(10);
    }          //Yaw,Ҫֹ1s
}

void send(void)
{
		mpu6050_get_accdata();
		mpu6050_get_gyrodata();
		uart_putchar(UART_2,0x03);
		uart_putchar(UART_2,~0x03);
		
		uart_putchar(UART_2,mpu6050_acc_x);
		uart_putchar(UART_2,mpu6050_acc_x>>8);
		
		uart_putchar(UART_2,mpu6050_acc_y);
		uart_putchar(UART_2,mpu6050_acc_y>>8);
		
		uart_putchar(UART_2,mpu6050_acc_z);
		uart_putchar(UART_2,mpu6050_acc_z>>8);
		
		
		uart_putchar(UART_2,mpu6050_gyro_x);
		uart_putchar(UART_2,mpu6050_gyro_x>>8);
		
		uart_putchar(UART_2,mpu6050_gyro_y);
		uart_putchar(UART_2,mpu6050_gyro_y>>8);
		
		uart_putchar(UART_2,mpu6050_gyro_z);
		uart_putchar(UART_2,mpu6050_gyro_z>>8);
		
		uart_putchar(UART_2,~0x03);
		uart_putchar(UART_2,0x03);
}

